Index: /trunk/include/FlairSensorActuator/SimuCamera.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuCamera.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuCamera.h	(revision 68)
@@ -35,5 +35,5 @@
   * \brief Constructor
   *
-  * Construct a SimuCamera. Control part.
+  * Construct a SimuCamera.
 	* It will be child of the FrameworkManager.
   *
@@ -50,20 +50,4 @@
              uint8_t priority);
 
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuCamera. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param width width
-  * \param height height
-  * \param channels number of channels
-  * \param modelId Model id
-  * \param deviceId Camera id of the Model
-  */
-  SimuCamera(const core::IODevice *parent, std::string name, uint16_t width,
-             uint16_t height, uint8_t channels, uint32_t modelId,uint32_t deviceId);
 
   /*!
Index: /trunk/include/FlairSensorActuator/SimuGps.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuGps.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuGps.h	(revision 68)
@@ -38,5 +38,5 @@
   * \brief Constructor
   *
-  * Construct a simulation GPS. Control part.
+  * Construct a simulation GPS
   * It will be child of the FrameworkManager.
 	* 
@@ -49,17 +49,4 @@
   SimuGps(std::string name,
           NmeaGps::NMEAFlags_t NMEAFlags, uint32_t modelId,uint32_t deviceId,uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a simulation GPS. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId Gps id of the Model
-  */
-  SimuGps(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
@@ -77,5 +64,5 @@
   * \param data data from the parent to process
   */
-  void UpdateFrom(const core::io_data *data);
+  void UpdateFrom(const core::io_data *data){};
 
   /*!
Index: /trunk/include/FlairSensorActuator/SimuImu.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuImu.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuImu.h	(revision 68)
@@ -38,5 +38,5 @@
   * \brief Constructor
   *
-  * Construct a SimuImu. Control part.
+  * Construct a SimuImu.
 	* It will be child of the FrameworkManager.
   *
@@ -48,17 +48,4 @@
   SimuImu(std::string name,
           uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuImu. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId Imu id of the Model
-  */
-  SimuImu(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
@@ -84,5 +71,5 @@
   * \param data data from the parent to process
   */
-  void UpdateFrom(const core::io_data *data);
+  void UpdateFrom(const core::io_data *data){};
 
   typedef struct {
Index: /trunk/include/FlairSensorActuator/SimuLaser.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuLaser.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuLaser.h	(revision 68)
@@ -37,6 +37,5 @@
   * \brief Constructor
   *
-  * Construct a SimuUs. Control part.
-	* It will be child of the FrameworkManager.
+  * Construct a SimuUs.
   *
   * \param name name
@@ -47,17 +46,4 @@
   SimuLaser(std::string name,
             uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuUs. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId LaserRangeFinder id of the Model
-  */
-  SimuLaser(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
Index: /trunk/include/FlairSensorActuator/SimuUs.h
===================================================================
--- /trunk/include/FlairSensorActuator/SimuUs.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/SimuUs.h	(revision 68)
@@ -37,5 +37,5 @@
   * \brief Constructor
   *
-  * Construct a SimuUs. Control part.
+  * Construct a SimuUs.
 	* It will be child of the FrameworkManager.
   *
@@ -47,17 +47,4 @@
   SimuUs(std::string name,
          uint32_t modelId,uint32_t deviceId, uint8_t priority);
-
-  /*!
-  * \brief Constructor
-  *
-  * Construct a SimuUs. Simulation part.\n
-  * The Thread of this class should not be run.
-  *
-  * \param parent parent
-  * \param name name
-  * \param modelId Model id
-  * \param deviceId UsRangeFinder id of the Model
-  */
-  SimuUs(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
 
   /*!
Index: /trunk/include/FlairSensorActuator/TargetController.h
===================================================================
--- /trunk/include/FlairSensorActuator/TargetController.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/TargetController.h	(revision 68)
@@ -27,5 +27,5 @@
 namespace core {
 class FrameworkManager;
-class cvmatrix;
+class Matrix;
 class Socket;
 class io_data;
@@ -82,6 +82,6 @@
   // axis stuff
   unsigned int axisNumber;
-  core::cvmatrix *axis = NULL;
-  virtual void AcquireAxisData(core::cvmatrix &axis) = 0; // responsible for
+  core::Matrix *axis = NULL;
+  virtual void AcquireAxisData(core::Matrix &axis) = 0; // responsible for
                                                           // getting the axis
                                                           // data from the
@@ -90,6 +90,6 @@
   // button stuff
   unsigned int buttonNumber;
-  core::cvmatrix *button = NULL;
-  virtual void AcquireButtonData(core::cvmatrix &button) = 0; // responsible for
+  core::Matrix *button = NULL;
+  virtual void AcquireButtonData(core::Matrix &button) = 0; // responsible for
                                                               // getting the
                                                               // button data
Index: /trunk/include/FlairSensorActuator/TargetEthController.h
===================================================================
--- /trunk/include/FlairSensorActuator/TargetEthController.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/TargetEthController.h	(revision 68)
@@ -27,5 +27,5 @@
 namespace core {
 class FrameworkManager;
-class cvmatrix;
+class Matrix;
 class TcpSocket;
 class UdpSocket;
@@ -62,7 +62,7 @@
 
   bool IsDataFrameReady();
-  void AcquireAxisData(core::cvmatrix &axis);     // responsible for getting the
+  void AcquireAxisData(core::Matrix &axis);     // responsible for getting the
                                                   // axis data from the hardware
-  void AcquireButtonData(core::cvmatrix &button); // responsible for getting the
+  void AcquireButtonData(core::Matrix &button); // responsible for getting the
                                                   // button data from the
                                                   // hardware
Index: /trunk/include/FlairSensorActuator/UsRangeFinder.h
===================================================================
--- /trunk/include/FlairSensorActuator/UsRangeFinder.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/UsRangeFinder.h	(revision 68)
@@ -17,14 +17,14 @@
 
 namespace flair {
-namespace core {
-class cvmatrix;
-}
-namespace gui {
-class Tab;
-class TabWidget;
-class GroupBox;
-class Layout;
-class DataPlot1D;
-}
+  namespace core {
+    class Matrix;
+  }
+  namespace gui {
+    class Tab;
+    class TabWidget;
+    class GroupBox;
+    class Layout;
+    class DataPlot1D;
+  }
 }
 
@@ -105,4 +105,11 @@
   */
   gui::Tab *GetPlotTab(void) const;
+  
+  /*!
+  * \brief Tab widget
+  *
+  * \return tab widget
+  */
+  gui::TabWidget *GetTabWidget(void) const;
 
   /*!
@@ -119,5 +126,5 @@
   * \return output matrix
   */
-  core::cvmatrix *output;
+  core::Matrix *output;
 
   /*!
Index: /trunk/include/FlairSensorActuator/VrpnObject.h
===================================================================
--- /trunk/include/FlairSensorActuator/VrpnObject.h	(revision 67)
+++ /trunk/include/FlairSensorActuator/VrpnObject.h	(revision 68)
@@ -21,5 +21,5 @@
 namespace flair {
 	namespace core {
-		class cvmatrix;
+		class Matrix;
 		class Quaternion;
 	}
@@ -126,5 +126,5 @@
   * \return Output matrix
   */
-  core::cvmatrix *Output(void) const;
+  core::Matrix *Output(void) const;
 
   /*!
@@ -139,5 +139,5 @@
   * \return State matrix
   */
-  core::cvmatrix *State(void) const;
+  core::Matrix *State(void) const;
 
   /*!
Index: /trunk/include/FlairSimulator/SimuBldc.h
===================================================================
--- /trunk/include/FlairSimulator/SimuBldc.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuBldc.h	(revision 68)
@@ -0,0 +1,80 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuBldc.h
+ * \brief Class for a simulation bldc
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMUBLDC_H
+#define SIMUBLDC_H
+
+#include <IODevice.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+}
+
+namespace flair {
+namespace actuator {
+/*! \class SimuBldc
+*
+* \brief Class for a simulation bldc
+*
+*/
+class SimuBldc : public core::IODevice {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimuBldc
+  *
+  * \param parent parent
+  * \param name name
+  * \param motors_count number of motors
+  * \param modelId Model id
+  * \param deviceId Bldc id of the Model
+  */
+  SimuBldc(const core::Object *parent, std::string name, uint8_t motors_count,
+           uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuBldc();
+
+  /*!
+  * \brief Get motors speeds.
+  *
+  *
+  * \param value array to store motors speeds
+  * \param time time when shared memory was written
+  */
+  void GetSpeeds(float *value,core::Time* time) const;
+
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  core::SharedMem *shmem;
+  char *buf;
+  uint8_t motors_count;
+
+};
+} // end namespace actuator
+} // end namespace flair
+#endif // SIMUBLDC_H
Index: /trunk/include/FlairSimulator/SimuCamera.h
===================================================================
--- /trunk/include/FlairSimulator/SimuCamera.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuCamera.h	(revision 68)
@@ -0,0 +1,77 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuCamera.h
+ * \brief Class for a simulation camera
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/03/06
+ * \version 4.0
+ */
+
+#ifndef SIMUCAMERA_H
+#define SIMUCAMERA_H
+
+#include <IODevice.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimuCamera
+*
+* \brief Class for a simulation camera
+*/
+class SimuCamera : public core::IODevice {
+public:
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimuCamera. 
+  *
+  * \param parent parent
+  * \param name name
+  * \param width width
+  * \param height height
+  * \param channels number of channels
+  * \param modelId Model id
+  * \param deviceId Camera id of the Model
+  */
+  SimuCamera(const core::IODevice *parent, std::string name, uint16_t width,
+             uint16_t height, uint8_t channels, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuCamera();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMUCAMERA_H
Index: /trunk/include/FlairSimulator/SimuGps.h
===================================================================
--- /trunk/include/FlairSimulator/SimuGps.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuGps.h	(revision 68)
@@ -0,0 +1,74 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuGps.h
+ * \brief Class for a simulation GPS
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2013/08/23
+ * \version 4.0
+ */
+
+#ifndef SIMUGPS_H
+#define SIMUGPS_H
+
+#include <IODevice.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimuGps
+*
+* \brief Class for a simulation GPS
+*/
+class SimuGps : public core::IODevice {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a simulation GPS.
+  *
+  * \param parent parent
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId Gps id of the Model
+  */
+  SimuGps(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuGps();
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data);
+
+  typedef struct {
+    float e;
+    float n;
+    float u;
+    float ve;
+    float vn;
+  } gps_states_t;
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+  core::SharedMem *shmem;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMUGPS_H
Index: /trunk/include/FlairSimulator/SimuImu.h
===================================================================
--- /trunk/include/FlairSimulator/SimuImu.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuImu.h	(revision 68)
@@ -0,0 +1,82 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuImu.h
+ * \brief Class for a simulation Imu
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMUIMU_H
+#define SIMUIMU_H
+
+#include <IODevice.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimuImu
+*
+* \brief Class for a simulation Imu
+*/
+class SimuImu : public core::IODevice {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimuImu.
+  *
+  * \param parent parent
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId Imu id of the Model
+  */
+  SimuImu(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuImu();
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data);
+
+  typedef struct {
+    float q0;
+    float q1;
+    float q2;
+    float q3;
+    float wx;
+    float wy;
+    float wz;
+    float ax;
+    float ay;
+    float az;
+    float mx;
+    float my;
+    float mz;
+  } imu_states_t;
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+  core::SharedMem *shmem;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMUIMU_H
Index: /trunk/include/FlairSimulator/SimuLaser.h
===================================================================
--- /trunk/include/FlairSimulator/SimuLaser.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuLaser.h	(revision 68)
@@ -0,0 +1,73 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuUs.h
+ * \brief Class for a simulation UsRangeFinder
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMULASER_H
+#define SIMULASER_H
+
+#include <LaserRangeFinder.h>
+#include <Thread.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimuUs
+*
+* \brief Class for a simulation UsRangeFinder
+*/
+class SimuLaser : public core::IODevice {
+public:
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimuUs.
+  *
+  * \param parent parent
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId LaserRangeFinder id of the Model
+  */
+  SimuLaser(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuLaser();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULASER_H
Index: /trunk/include/FlairSimulator/SimuUs.h
===================================================================
--- /trunk/include/FlairSimulator/SimuUs.h	(revision 68)
+++ /trunk/include/FlairSimulator/SimuUs.h	(revision 68)
@@ -0,0 +1,83 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimuUs.h
+ * \brief Class for a simulation UsRangeFinder
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMUUS_H
+#define SIMUUS_H
+
+#include <IODevice.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+namespace gui {
+class SpinBox;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimuUs
+*
+* \brief Class for a simulation UsRangeFinder
+*/
+class SimuUs : public core::IODevice {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimuUs
+  *
+  * \param parent parent
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId UsRangeFinder id of the Model
+  */
+  SimuUs(const core::IODevice *parent, std::string name, uint32_t modelId,uint32_t deviceId);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimuUs();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  gui::SpinBox *data_rate;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMUUS_H
Index: /trunk/include/FlairSimulator/X4.h
===================================================================
--- /trunk/include/FlairSimulator/X4.h	(revision 67)
+++ /trunk/include/FlairSimulator/X4.h	(revision 68)
@@ -26,4 +26,5 @@
 namespace gui {
 class DoubleSpinBox;
+class SpinBox;
 }
 namespace actuator {
@@ -63,4 +64,5 @@
   gui::DoubleSpinBox *f_air_vert, *f_air_lat;
   gui::DoubleSpinBox *j_roll, *j_pitch, *j_yaw;
+  gui::SpinBox *motorTimeout;
 };
 } // end namespace simulator
Index: /trunk/include/FlairSimulator/X8.h
===================================================================
--- /trunk/include/FlairSimulator/X8.h	(revision 67)
+++ /trunk/include/FlairSimulator/X8.h	(revision 68)
@@ -26,4 +26,5 @@
 namespace gui {
 class DoubleSpinBox;
+class SpinBox;
 }
 namespace actuator {
@@ -65,4 +66,5 @@
   gui::DoubleSpinBox *j_roll, *j_pitch, *j_yaw;
   gui::DoubleSpinBox *j_r, *sigma, *S;
+  gui::SpinBox *motorTimeout;
 };
 } // end namespace simulator
Index: /trunk/include/FlairVisionFilter/HoughLines.h
===================================================================
--- /trunk/include/FlairVisionFilter/HoughLines.h	(revision 67)
+++ /trunk/include/FlairVisionFilter/HoughLines.h	(revision 68)
@@ -17,5 +17,5 @@
     namespace core {
         class cvimage;
-        class cvmatrix;
+        class Matrix;
     }
     namespace gui {
@@ -56,5 +56,5 @@
             float GetOrientation(void) const;
             float GetDistance(void) const;
-            core::cvmatrix *Output(void) const;
+            core::Matrix *Output(void) const;
 
         private:
@@ -69,5 +69,5 @@
             float distance,orientation;
             CvMat* linesStorage;
-            core::cvmatrix *output;
+            core::Matrix *output;
     };
 } // end namespace filter
Index: /trunk/include/FlairVisionFilter/OpticalFlowSpeed.h
===================================================================
--- /trunk/include/FlairVisionFilter/OpticalFlowSpeed.h	(revision 67)
+++ /trunk/include/FlairVisionFilter/OpticalFlowSpeed.h	(revision 68)
@@ -17,5 +17,5 @@
     namespace core
     {
-        class cvmatrix;
+        class Matrix;
     }
 }
@@ -71,5 +71,5 @@
             * Second line is speed along y axis. \n
             */
-            core::cvmatrix *Output() const;
+            core::Matrix *Output() const;
 
         private:
@@ -83,5 +83,5 @@
             void UpdateFrom(const core::io_data *data);
 
-            core::cvmatrix *output;
+            core::Matrix *output;
     };
 } // end namespace filter
Index: /trunk/scripts/cmake_codelite.sh
===================================================================
--- /trunk/scripts/cmake_codelite.sh	(revision 67)
+++ /trunk/scripts/cmake_codelite.sh	(revision 68)
@@ -1,3 +1,3 @@
-DIR=build_$(uname -m)
+#!/bin/bash
 
 function info () {
@@ -14,4 +14,8 @@
 }
 
+if [ $(uname -m) != "x86_64" ]; then
+    err "unsupported host architecture, you need a x86_64 cpu"
+fi
+
 if ! [ -f  ./CMakeLists.txt ]; then
 	err "Current directory does not contain CMakeLists.txt"
@@ -27,5 +31,5 @@
 		err "Error: build already exsits and is a directory; it should be a symlink."
 	fi
-	if ! readlink build | grep -w $DIR >/dev/null; then
+	if ! readlink build | grep -w build_core2_64 >/dev/null; then
 		warn "Warnink, build was pointing to another directory."
 	fi
@@ -33,25 +37,18 @@
 fi
 
-#creation du repertoire
-mkdir -p $DIR
+#iterate over available toolchains
+toolchains=($OECORE_CMAKE_TOOLCHAINS)
+for arch in ${toolchains[@]}; do
+    info "*************  Creating project for $arch *************"
+    toolchain=$(eval "echo \"\$OECORE_CMAKE_${arch^^}_TOOLCHAIN\"")
+    mkdir -p build_${arch}
+    cd build_${arch}
+    rm -f CMakeCache.txt
+    rm -rf CMakeFiles
+
+    ${CMAKE} ../ -G "CodeLite - Unix Makefiles" -DCMAKE_TOOLCHAIN_FILE=${toolchain} -DCMAKE_CODELITE_USE_TARGETS=ON
+    cd ..
+done
+
 #creation du lien symbolique
-ln -s $DIR build
-
-#creation project x86
-info "*************  Creating project for x86 *************"
-cd build
-rm -f CMakeCache.txt
-rm -rf CMakeFiles
-${CMAKE} ../ -G "CodeLite - Unix Makefiles" -DCMAKE_TOOLCHAIN_FILE=${OECORE_CMAKE_HOST_TOOLCHAIN} -DCMAKE_CODELITE_USE_TARGETS=ON
-# -DCMAKE_BUILD_TYPE=Release 
-
-#creation projet ARM
-info "************* Creating project for ARM *************"
-cd ..
-mkdir -p build_arm
-cd build_arm
-rm -f CMakeCache.txt
-rm -rf CMakeFiles
-
-${CMAKE} ../ -G "CodeLite - Unix Makefiles" -DCMAKE_TOOLCHAIN_FILE=${OECORE_CMAKE_CROSS_TOOLCHAIN} -DCMAKE_CODELITE_USE_TARGETS=ON
-# -DCMAKE_BUILD_TYPE=Release
+ln -s build_core2_64 build
Index: /trunk/scripts/flair_compile_all.sh
===================================================================
--- /trunk/scripts/flair_compile_all.sh	(revision 67)
+++ /trunk/scripts/flair_compile_all.sh	(revision 68)
@@ -4,4 +4,5 @@
 from_scratch=no
 IDE_SCRIPT=cmake_codelite.sh
+toolchains=($OECORE_CMAKE_TOOLCHAINS)
 
 function green_echo () {
@@ -32,5 +33,4 @@
 		cd $1/$2
 
-		rm -f build_arm/CMakeCache.txt
 		$FLAIR_ROOT/flair-dev/scripts/$IDE_SCRIPT > /dev/null
 	
@@ -41,20 +41,14 @@
 }
 
-function cross_compile () {
-	green_echo "Cross compiling and installing $2"
-	cd $1/$2/build_arm
-	if [ "$from_scratch" = "yes" ]; then make clean > /dev/null; fi
-	make -j$NB_THREADS > /dev/null
-	check_error
-	make install
-}
-
 function compile () {
-	green_echo "Compiling and installing $2"
-	cd $1/$2/$ARCH_DIR
-	if [ "$from_scratch" = "yes" ]; then make clean > /dev/null; fi
-	make -j$NB_THREADS > /dev/null
-	check_error	
-	make install
+    #iterate over available toolchains
+    for arch in ${toolchains[@]}; do
+        green_echo "Compiling and installing $2 for $arch"
+        cd $1/$2/build_$arch
+	    if [ "$from_scratch" = "yes" ]; then make clean > /dev/null; fi
+	    make -j$NB_THREADS > /dev/null
+	    check_error	
+	    make install
+    done
 }
 
@@ -63,12 +57,10 @@
 		configure $FLAIR_ROOT/flair-src/lib $projects
 	   	compile $FLAIR_ROOT/flair-src/lib $projects
-		cross_compile $FLAIR_ROOT/flair-src/lib $projects
 	done
 
 	if [ -d $FLAIR_ROOT/flair-hds ]; then
-		for projects in FlairBebop FlairArdrone2 VisionFilter; do
+		for projects in FlairBebop FlairArdrone2 FlairMinidrones VisionFilter; do
 			configure $FLAIR_ROOT/flair-hds/src/lib $projects
 		   	compile $FLAIR_ROOT/flair-hds/src/lib $projects
-			cross_compile $FLAIR_ROOT/flair-hds/src/lib $projects
 		done
 	fi
@@ -79,5 +71,4 @@
 		configure $FLAIR_ROOT/flair-src/tools $projects
 	   	compile $FLAIR_ROOT/flair-src/tools $projects
-		cross_compile $FLAIR_ROOT/flair-src/tools $projects
 	done
 }
@@ -87,5 +78,4 @@
 		configure $1/$2 $projects
 	   	compile $1/$2 $projects
-		cross_compile $1/$2 $projects
 	done
 }
@@ -95,5 +85,4 @@
 		configure $FLAIR_ROOT/flair-src/demos $projects
 	   	compile $FLAIR_ROOT/flair-src/demos $projects
-		cross_compile $FLAIR_ROOT/flair-src/demos $projects
 	done
 
@@ -105,5 +94,4 @@
 		configure $FLAIR_ROOT/flair-src/demos/Skeletons $projects
 	   	compile $FLAIR_ROOT/flair-src/demos/Skeletons $projects
-		cross_compile $FLAIR_ROOT/flair-src/demos/Skeletons $projects
 	done
 
